
using System;
using NHibernate.BusinessObjects;
using Iesi.Collections.Generic;


namespace Tutorial
{
	// Business object implementation

	[Serializable]
	public sealed class Address : BusinessObject, IAddress, IVisitable
	{
	
		private Address()
		{
			try
			{
			}
			catch(Exception e)
			{
				throw new BusinessException(EBusinessError.FatalError, "Could not create object of type 'Tutorial.Address'.", e);
			}
		}
		

		#region IAddress Properties


		private System.String _street;
		public System.String Street 
		{ 
			get
			{
				try
				{
					return _street;
				}
				catch (Exception e)
				{
					throw new BusinessException(EBusinessError.ReadError, "Could not read value from property 'Street'.", e);
				}
			} 
			set
			{
				try
				{
					TestSession(); 
					TestObjectLock();
					_street = value;
					SetModified();
				}
				catch (Exception e)
				{
					throw new BusinessException(EBusinessError.WriteError, "Could not write value to property 'Street'.", e);
				}
			} 
		}
		

		private System.String _city;
		public System.String City 
		{ 
			get
			{
				try
				{
					return _city;
				}
				catch (Exception e)
				{
					throw new BusinessException(EBusinessError.ReadError, "Could not read value from property 'City'.", e);
				}
			} 
			set
			{
				try
				{
					TestSession(); 
					TestObjectLock();
					_city = value;
					SetModified();
				}
				catch (Exception e)
				{
					throw new BusinessException(EBusinessError.WriteError, "Could not write value to property 'City'.", e);
				}
			} 
		}
		

		private System.String _zip;
		public System.String Zip 
		{ 
			get
			{
				try
				{
					return _zip;
				}
				catch (Exception e)
				{
					throw new BusinessException(EBusinessError.ReadError, "Could not read value from property 'Zip'.", e);
				}
			} 
			set
			{
				try
				{
					TestSession(); 
					TestObjectLock();
					_zip = value;
					SetModified();
				}
				catch (Exception e)
				{
					throw new BusinessException(EBusinessError.WriteError, "Could not write value to property 'Zip'.", e);
				}
			} 
		}
		

		private System.String _state;
		public System.String State 
		{ 
			get
			{
				try
				{
					return _state;
				}
				catch (Exception e)
				{
					throw new BusinessException(EBusinessError.ReadError, "Could not read value from property 'State'.", e);
				}
			} 
			set
			{
				try
				{
					TestSession(); 
					TestObjectLock();
					_state = value;
					SetModified();
				}
				catch (Exception e)
				{
					throw new BusinessException(EBusinessError.WriteError, "Could not write value to property 'State'.", e);
				}
			} 
		}
		

		private System.String _country;
		public System.String Country 
		{ 
			get
			{
				try
				{
					return _country;
				}
				catch (Exception e)
				{
					throw new BusinessException(EBusinessError.ReadError, "Could not read value from property 'Country'.", e);
				}
			} 
			set
			{
				try
				{
					TestSession(); 
					TestObjectLock();
					_country = value;
					SetModified();
				}
				catch (Exception e)
				{
					throw new BusinessException(EBusinessError.WriteError, "Could not write value to property 'Country'.", e);
				}
			} 
		}
		

		#endregion
		
		#region Methods
		
		#endregion //Methods

		#region Acyclic visitor
		
		public override T Apply<T>(IVisitor<T> visitor)
		{
			var specificVisitor = visitor as IAddressVisitor<T>;
			
			return specificVisitor != null ? specificVisitor.Visit(this) : base.Apply(visitor);
		}
		
		#endregion //Acyclic visitor
	}
}


