
using NHibernate.BusinessObjects;


namespace Tutorial
{
	

	// Business object interface
	public interface IPerson : IBusinessObject
	{
		#region Properties
				
		System.String Name { get; set; }

		System.String FirstName { get; set; }

		System.Int32 Age { get; set; }

		Tutorial.IAddress Address { get; }

		#endregion //Properties
		
		#region Methods
		
		#endregion //Methods
		
	}
	
	// IBusinessSession Extensions
	public static class PersonSessionExtensions
	{
		public static IPerson CreatePerson(this IBusinessSession session)
		{
			var methodInfo = session.GetType().GetMethod("CreateObject").MakeGenericMethod(new System.Type[]{typeof(IPerson)});

			return (IPerson)methodInfo.Invoke(session, new object[] { });
		}

		public static void DeletePerson(this IBusinessSession session, IPerson bo)
		{
			var methodInfo = session.GetType().GetMethod("DeleteObject").MakeGenericMethod(new System.Type[]{typeof(IPerson)});

			methodInfo.Invoke(session, new object[] { bo });
		}
	}

	// Acyclic visitor interface
	public interface IPersonVisitor<T> : IVisitor<T>
	{
		T Visit(IPerson visitable);
	}
}

